<?php
/*
* Copyright (c) 2002-2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * HOWTO RUN THIS SCRIPT
 * First, please rename the cronOthumb script and place it in the LinPHA rootdir
 * run curl as follows: 
 * curl --max-time 50000 -d admin=adminname -d pass=adminpass http://localhost/linpha/howYouNamedTheScript.php
 * Optional Settings:
 * 
 * -d directories=nothing (to prevent create/update of directories)
 * -d thumbnails=nothing (to prevent create/update of thumbnails)
 * -d exif=nothing (to prevent create/update of EXIF data)
 * -d iptc=nothing (to prevent create/update of IPTC data)
 * -d silent=true (run silent, no debug messages)
 * append '> out_cronOthumb.html' to have output formatted in HTML in a human readable file 
 * 
 * For security reasons, the recreate of directories is denied!
 */

if(!defined('TOP_DIR')) { define('TOP_DIR','.'); }

/**
 * show errors if php run into a time or memory limit for example!
 */
error_reporting(1);
@set_time_limit(0);

include_once(TOP_DIR.'/include/session.php');
include_once(TOP_DIR.'/plugins/cache/func.cache.php');
include_once(language_file());

$password = "";
$password = $_POST['pass'];

$query = $GLOBALS['db']->Execute("SELECT password FROM ".PREFIX."users " .
		"WHERE nickname = '".$_POST['admin']."' " .
		"AND groups LIKE '%admin%'" .
		"OR groups LIKE ';1;'");
$result = $query->FetchRow();

if(md5($password) === $result[0])
{
/**
 * directories
 */
if($_POST['directories'] != 'nothing')
{
    echo "<b>Starting update of files and folders (and prepare md5sum for images)</b><br /><br />";
    
    if($_REQUEST['directories'] == 'recreate')
    {
    	echo "NOT GOING TO RECREATE!";
    }
    
    /**
    * disable autocreate of thumbs in config to prevent trouble
    */
    if(read_config('autoconf')){
    	update_config(0, 'autoconf');
    	$auto_config = true;
    } else {
    	$auto_config = false;
    }
    
    /**
     * if we have adocache enabled, make sure to clear all cached entries
     * otherwise the menu will be broken after the rebuild
     */
    if(read_config('adodb_caching')){
        $GLOBALS['db']->CacheFlush();
        echo "Flushing Cache...<br>";
    }
    
    
    /* call first level to create required entries */
    first_lev_funct();
    
    print("$parse_first<br>");
    flush();
    /* initialize counter var */
    $parse_count=0;
    
    /* run sec_lev_function for every registered entry in first_lev_album */
    $query_first=$GLOBALS['db']->Execute("SELECT path, name FROM ".PREFIX."first_lev_album");
    
    while($row=$query_first->FetchRow())
    {
    		$parse_count++;
    		sec_lev_funct($row[0], $row[1], $came_from_first=false);
    		echo "$parse: <b>$row[1]</b><br>";
    		flush();
    }
    
    print("$parsed $parse_count $dirs<br><br>");
    flush();
    print("$parse_sec<br>");
    flush();
    /* run third_lev_funct for every registered entry in sec_lev_album */
    $query_sec=$GLOBALS['db']->Execute("SELECT path, name FROM ".PREFIX."sec_lev_album");
    $parse_count=0;
    while($row=$query_sec->FetchRow())
    {
    		if($row[1]!="has_images")
    	{
    		$parse_count++;
    		third_lev_funct($row[0], $row[1], $call_from_delete=false);
    		echo "$parse: <b>$row[1]</b><br>";
    		flush();
    	}
    }
    
    print("$parsed $parse_count $dirs<br><br>");
    flush();
    print("$parse_third<br>");
    flush();
    
    /* run forth_lev_funct for every registered entry in third_lev_album */
    $query_third=$GLOBALS['db']->Execute("SELECT path, name FROM ".PREFIX."third_lev_album");
    $parse_count=0;
    while($row=$query_third->FetchRow())
    {
    		if($row[1]!="has_images")
    	{
    		$parse_count++;
    		forth_lev_funct($row[0], $row[1]);
    		echo "$parse:<b>$row[1]</b><br>";
    		flush();
    	}
    }
    
    // write back folder settings (groups) in first_lev_album
    $counter=0;
    while(list($album_name, $allowed_groups)=@each($backup_array[$counter]))
    {
    	$update_query=$GLOBALS['db']->Execute("UPDATE ".PREFIX."first_lev_album
    								SET groups='$allowed_groups' 
    								WHERE name='".linpha_addslashes($album_name)."'");
    $counter++;
    }
    // write back number of pictures TODO: use ONE array for groups AND pictures 
    $counter=0;
    while(list($album_name, $num_of_images)=@each($imageno_array[$counter]))
    {
    	$update_query=$GLOBALS['db']->Execute("UPDATE ".PREFIX."first_lev_album
    								SET photos='$num_of_images' 
    								WHERE name='".linpha_addslashes($album_name)."'");
    $counter++;
    }
    unset($backup_array, $imageno_array);
    
    echo "$parsed $parse_count $dirs<br /><br /><br />$done<br /><br /><br />";

    /* enable autocreate of thumbs in config */
    if($auto_config):update_config(1, 'autoconf');endif;
}

/**
 * thumbnails
 */
if($_POST['thumbnails'] != 'nothing')
{
	/**
	 * default values for progress info (startcondition)
 	*/
	$echopoint = 0;
	
    echo "<b>Starting create/recreate of thumbnails</b><br /><br />";
    if($_POST['thumbnails'] == 'recreate')
    {
        echo "Deleting all existing thumbnails... ";
        flush();
        $db->Execute("UPDATE ".PREFIX."photos SET thumbnail = NULL");
        echo "<b>done!</b><br /><br />";
        flush();
    }
    
    $query = $db->Execute("SELECT count(*) FROM ".PREFIX."photos");
    $data = $query->FetchRow();
    $max = $data[0];
    
    $query = $db->Execute("SELECT id, prev_path, filename FROM ".PREFIX."photos WHERE thumbnail is NULL");
    $num = $query->RecordCount();
    
    echo $num." of ".$max." thumbnails need to be created<br /><br />";
    flush();
    
    $counter = 1;
    while($data = $query->FetchRow(ADODB_FETCH_ASSOC))
    {

    	$done = number_format(($counter*100)/$num, 2 , '.', '');
    	$counter++;   
    	$src_file = "".$data['prev_path'].'/'.$data['filename']."";
        //echo "<b>".$done." % done</b>, creating thumbnail for: ".$data['prev_path'].'/'.$data['filename']." ";
		progress($done, $src_file);        
        
        if(file_exists(TOP_DIR.'/'.$data['prev_path'].'/'.$data['filename']))
        {
            make_thumb($data['id']);
        }
        else
        {
            echo "Warning file does not exists anymore: Consider create/recreate Directories first!";
        }
    }
    echo "<br /><br />";
}

/**
 * exif
 */
if($_POST['exif'] != 'nothing')
{
	/**
 	* default values for progress info (startcondition)
 	*/
	$echopoint = 0;
    
    echo "<b>Reading EXIF information</b><br /><br />";
    
    include_once(TOP_DIR.'/include/metadata.class.php');
    include_once(TOP_DIR.'/include/phpmeta/EXIF.php');
    $metadata = new MetaData();
    
    if($_REQUEST['exif'] == 'recreate')
    {
    	echo "NOT GOING TO RECREATE!";
    }

    $query = $db->Execute("SELECT count(*) FROM ".PREFIX."photos WHERE level = '0'");
    $data = $query->FetchRow();
    $max = $data[0];
    
    $query = $db->Execute("SELECT p.id, p.md5sum, p.prev_path, p.filename ".
        "FROM ".PREFIX."photos AS p LEFT OUTER JOIN ".PREFIX."meta_exif AS e ".
        "ON e.md5sum = p.md5sum WHERE e.md5sum is NULL AND level = '0'");
    $num = $query->RecordCount();
    
    echo $num." of ".$max." files need to be read<br /><br />";
    flush();

	$counter=1;
    while($data = $query->FetchRow(ADODB_FETCH_ASSOC))
    {
        $src_file = TOP_DIR.'/'.$data['prev_path'].'/'.$data['filename'];
    	
    	$done = number_format(($counter*100)/$num, 2 , '.', '');        
    	$counter++;
    	
		progress($done, $src_file);
        
        if(file_exists($src_file))
        {
            $metadata->saveExifData($src_file,$data['md5sum']);
        }
        else
        {
            echo "Warning file does not exists anymore: Consider create/recreate Directories first!";
        }
    }
    echo "<br /><br />";
}

/**
 * iptc
 */
if($_POST['iptc'] != 'nothing')
{
	/**
 	* default values for progress info (startcondition)
 	*/
	$echopoint = 0;	
    
    echo "<b>Reading IPTC information</b><br /><br />";
    
    if(!isset($metadata))
    {
        include_once(TOP_DIR.'/include/metadata.class.php');
        $metadata = new MetaData();
    }
    include_once(TOP_DIR.'/include/phpmeta/Photoshop_IRB.php'); 
    include_once(TOP_DIR.'/include/phpmeta/JPEG.php');
    
    if($_REQUEST['iptc'] == 'recreate')
    {
    	echo "NOT GOING TO RECREATE!";
    }
    
    $query = $db->Execute("SELECT count(*) FROM ".PREFIX."photos WHERE level = '0'");
    $data = $query->FetchRow();
    $max = $data[0];
    
    $query = $db->Execute("SELECT p.id, p.md5sum, p.prev_path, p.filename ".
        "FROM ".PREFIX."photos AS p LEFT OUTER JOIN ".PREFIX."meta_iptc AS e ".
        "ON e.md5sum = p.md5sum WHERE e.md5sum is NULL AND level = '0'");
    $num = $query->RecordCount();
    
    echo $num." of ".$max." files need to be read<br /><br />";
    flush();
	
	$counter = 1;
    while($data = $query->FetchRow(ADODB_FETCH_ASSOC))
    {
        $src_file = TOP_DIR.'/'.$data['prev_path'].'/'.$data['filename'];
    	
    	$done = number_format(($counter*100)/$num, 2 , '.', '');
    	$counter++;
    	
		progress($done, $src_file);
		
        if(file_exists($src_file))
        {
            $metadata->saveIptcData($src_file,$data['md5sum']);
        }
        else
        {
            echo "Warning file does not exists anymore: Consider create/recreate Directories first!";
        }
    }
    echo "<br /><br />";
}

/**
 * if cache is disabled, nothing will happen
 */
photo_cache_cleanup_invalid($force=false);

echo "<a href='index.php'><font color='#000033'><strong>".$admin_task."</strong></font></a><br /><br />";
echo "<a href='".TOP_DIR."/admin.php?page=other'><font color='#000033'><strong>".STR_BACK."</strong></font></a> ";

}
else
{
	echo "ACCESS DENIED!!";
	echo "Maybe wrong user and or password!";
}

/**
 * This method takes care of the progress info in creating iptc/exif and thumbs.
 * It features 2 ways of info, either silent (show only percentage progress in
 * 5% steps, or info for each single file )
 */
function progress($done, $src_file)
{
	global $echopoint;
	
	if(!$_POST['silent'])
	{
    	echo "<b>".$done." % done</b>, working on file: ".$src_file." ";
    	echo "<br />";
    	flush();
	}
	else
	{
    	if(intval($done) >= $echopoint)
    	{
    		echo "<b>".round($done)." % done</b>";
    	    echo "<br />";
    		flush();	
    		$echopoint = $echopoint+5;
    	}
	}
}
	
?>